#include <stddef.h>
#include <stdio.h>
#include <io.h>

#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "types.h"
#include "raster.h"

#ifndef __UNIX__
 #include <io.h>
#endif

#include <matrix.h>


#ifdef RasImg

#include <alloc.h>

extern Image LoadPicture(const char *Name);
extern int SavePicture(const char *Name,const Image &Img);



const char *GetExtension(const char *FullName)
{
const char *NameStep;
int LastPos;

if(FullName==NULL) return(NULL);

LastPos=strlen(FullName);
NameStep=FullName+LastPos+1;
while(NameStep>FullName)
	{
	NameStep--;

	if(*NameStep=='/' || *NameStep=='\\' || *NameStep==':')
		break;
	if(*NameStep=='.')
		return(NameStep);
	}

return(FullName+LastPos);
}

////////////////////////////////////////////////////////////////////

static Image PeelPlane_(Image Img, int PlaneNum)
{
Raster2DAbstract *Raster=NULL;
Image NewImg;
int y;

 if(Img.Raster!=NULL)
  {
  Raster = CreateRaster2D(Img.Raster->Size1D,Img.Raster->Size2D,1);
  if(Raster)
    for(y=0;y<Img.Raster->Size2D;y++)		// main row loop
      {
      Img.Raster->GetRowRaster(y)->Peel1Bit(Raster->GetRowRaster(y)->Data1D,PlaneNum);
      }
  }

  if(Raster!=NULL) {NewImg.Raster=Raster; NewImg.Raster->UsageCount++;}
  if(Img.Palette!=NULL) {NewImg.Palette=Img.Palette; NewImg.Palette->UsageCount++;}

return(NewImg);
}



Image Mask(Image &im_in, int size)
{
Image im_out;
Raster2DAbstract *Raster=NULL;
WORD k,k2;
WORD i,j;
WORD x,y;
int y1,y2,x1,x2;
DWORD aLl;
BYTE *ptrLine;
WORD *ptrLineW;
BYTE color,clr;

 if(im_in.Raster!=NULL)
  {
  Raster = CreateRaster2D(im_in.Raster->Size1D,im_in.Raster->Size2D,im_in.Raster->GetPlanes());
  if(Raster)
    for(y=0;y<im_in.Raster->Size2D;y++)		// main row loop
      {
//      im_in.Raster->GetRowRaster(y)->Peel1Bit(Raster->GetRowRaster(y)->Data1D,PlaneNum);
      }
  }

  if(Raster!=NULL) {im_out.Raster=Raster; im_out.Raster->UsageCount++;}
// if(Img.Palette!=NULL) {NewImg.Palette=Img.Palette; NewImg.Palette->UsageCount++;}

return im_out;

/*

Label 10;
begin
Obr2.Erase;
if (n=0)or(not(Obr1.Valid)) then exit;
Obr2.Create(Obr1.x,Obr1.y,Obr1.Planes);
if not(Obr2.Valid) then exit;

if AlineProc<>nil then
	AlineProc^.InitPassing(Obr1.y,'Filtering by MASK');

Getmem(ukRadek,4*Obr1.x);
Getmem(ukRadekW,2*Obr1.x);
k:=n*n;
k2:=k div 2;
x:=n div 2+1;
y:=n div 2+1;

color:=1;
if(Obr1.typ='C') and (Obr1.planes=24) then
  begin
  color:=3;
  Obr2.typ:='C';
  if AlineProc<>nil then AlineProc^.pases := AlineProc^.pases*3;
  end;

for clr:=0 to color-1 do
  begin

  y1:=x + 1;
  if n<=2 then dec(y1);		{pocet pridanych radek}

  fillchar(ukradek^,4*Obr1.x,0);
  if color=1 then
    Obr1.formR(0,ukradekW)
  else
    PeelB2W(Obr1.x,addr(Obr1.data^[0]^.b[clr]),ukradekW,3);

  for j:=1 to y1 do SectiLW(Obr1.x,ukradek,ukradekW); {ukradek=y1*ukradekW}


  for y1:=1 to integer(n+1)div 2 - 2 do
    begin 			{pridani pripravnych radku}
    if color=1 then
      Obr1.formR(y1,ukradekW)
    else
      PeelB2W(Obr1.x,addr(Obr1.data^[y1]^.b[clr]),ukradekW,3);
    SectiLW(Obr1.x,ukradek,ukradekW);
    end;

  for i:=0 to Obr1.y-1 do		{hlavni filtracni smycka}
    begin
    y1:=integer(i)-y;
    y2:=y1+n;
    if y1<0 then y1:=0;
    if y2>=Obr1.y then y2:=Obr1.y-1;

    if color=1 then
      Obr1.formR(y1,ukradekW)
    else
      PeelB2W(Obr1.x,addr(Obr1.data^[y1]^.b[clr]),ukradekW,3);
    OdectiLw(Obr1.x,ukradek,ukradekW);	{vyjmuti posledniho radku y1}

    if color=1 then
      Obr1.formR(y2,ukradekW)
    else
      PeelB2W(Obr1.x,addr(Obr1.data^[y2]^.b[clr]),ukradekW,3);
    SectiLw(Obr1.x,ukradek,ukradekW);	{pridani noveho radku y2}
				{zpracovani obsahu radku}
    x1:=y + 1;
    if n<=2 then dec(x1);		{pocet pridanych sloupcu}
    All:=x1*ukradek^[0];
    for x2:=1 to integer(n+1)div 2 - 2 do inc(All,ukradek^[x2]);

    Sptr.ptr:=ukRadekW;		{vypocet masky v radku}
    x1:=-integer(x);
    x2:=min(x1+n,Obr1.x-1);
    SptrAl.ptr:=ukradek;
    SptrAr.ptr:=ukradek; inc(SptrAr.ptrL,x2);
    for j:=0 to Obr1.x-1 do
      begin
      dec(All,SptrAl.ptrL^);
      inc(All,SptrAr.ptrL^);
  
      asm		{    Sptr.PtrW^:=(Al+k2) div k;}
	PUSH	ES
	MOV	AX,word ptr All
	MOV	DX,word ptr All+2
	ADD	AX,k2
	ADC	DX,0
	DIV	k
	LES	DI,sptr
	STOSW
	POP	ES
      end;

      if x1>=0 then       inc(SptrAl.ptrL);
      if x2<Obr1.x-1 then inc(SptrAr.ptrL);
      inc(Sptr.PtrW);
      inc(x1);
      inc(x2);
      end;
    
    if color=1 then
      RfrmB(Obr2,i,ukRadekW)	{ulozeni dat}
    else
      JoinW2B(Obr2.x,addr(Obr2.data^[y2]^.b[clr]),ukradekW,3);	{ulozeni dat}

    if AlineProc<>nil then AlineProc^.NextLine;	{Dialog s uzivatelem}
    end;
  end;

FreeMem(ukRadekW,2*Obr1.x);
FreeMem(ukRadek,4*Obr1.x);
end;
*/
return(im_out);
}



/////////////////////Main CODE starts here/////////////////////////////////

char Verbosity = 0;

void PrintHeader(void)
{
char HdrPrinted=0;
  if(Verbosity>=0 && HdrPrinted==0)
    {
    puts("\n\r <<< CONVERT >>> Convert picture format (c)1997-2009 F&TSoft ");
    HdrPrinted=1;
    }
}


int main(int argc,char *argv[])
{
Image I1,I2;
const char *InputImg=NULL, *OutputImg=NULL;
const char *s;
TImageFileHandler *LoadPicture_XXX;
int i;
int PeelPlane=-1;
int Error = 0;

	/* Parse Arguments */
for(i=1;i<argc;i++)
  {
  s=argv[i];
  if(s==NULL) continue;
  if( *s==0 ) continue;

  if(*s=='-' || *s=='/')
    {
    if(strcmp(s+1,"help")==0 || strcmp(s+1,"-help")==0 || strcmp(s+1,"?")==0)
      {
        PrintHeader();
        printf("\n");
        for(LoadPicture_XXX=TImageFileHandler::first();LoadPicture_XXX!=NULL;LoadPicture_XXX=LoadPicture_XXX->next())
	  {
	  printf("%s %s%s; ",LoadPicture_XXX->extension(),
			     LoadPicture_XXX->LoadPicture==NULL?"":"R",
			     LoadPicture_XXX->SavePicture==NULL?"":"W");
	  }
	printf(//"\n/NoScale      - means truncating image data"
	       //"\n(not working yet) /Gray         - discards all color informations"
	       //"\n/SEPARATE[R|G|B] - remove one channel from true color images"
	       "\n/PeelPlane n  - cut only plane with number n"
	       "\n/s            - decrease verbosity level"
	       "\n");
        return(0);
      }
    if(strcmp(s+1,"PeelPlane") == 0)
      {
      PeelPlane = atoi(argv[++i]);
      continue;
      }
    if(strcmp(s+1,"s") == 0)
      {
      Verbosity = -1;
      continue;
      }
    }

  if(InputImg==NULL)
     InputImg=s;
  else
     if(OutputImg==NULL) OutputImg=s;
  }
	/* End of reading arguments */

  PrintHeader();
  if(Verbosity>=0) printf("\rLoading");
  //MarkTime=GetInterval();

//for(i=1;i<=10;i++)
  I1=LoadPicture(InputImg);
  if(I1.Raster==NULL && I1.Comment==NULL)
	{
	printf("\n\rCannot load input picture:\"%s\" Error %d",InputImg,Error);
	goto End;
	}

  //MarkTime=GetInterval();

  I1 = Mask(I1,3);

  if(Verbosity>=0) printf("\rSaving ");

  Error=SavePicture(OutputImg,I1);
  if(Error)
    {
    printf("\n\rCannot save output picture:\"%s\" Error %d",OutputImg,Error);
    }
  else
    {
    if(Verbosity>=0)
      {
      //printf("time : %f",abs(GetInterval()-MarkTime)/18.2);
      puts("\rOK     ");
      }
    }

End:
  return(Error);
}
#endif //Ras_img

